import Delegate;

class Sudoku{
	private var clip:MovieClip;
	private var CELLWIDTH:Number = 50;
	private var CELLHEIGHT:Number = 50;
	private var cells:Array;
	private var startingData:Array;
	
	function Sudoku(target:MovieClip){
		this.clip = target;
		//target.onLoad = Delegate.create(this,draw);
		
		
		//-----------------------------------------
		// STARTING DATA
		//-----------------------------------------
		/*var rows = new Array();
		rows.push(new Array(0,0,0,0,0,0,0,0,1));
		rows.push(new Array(3,0,0,0,7,8,4,5,0));
		rows.push(new Array(0,0,5,0,1,6,8,0,0));
		rows.push(new Array(6,7,0,8,0,0,1,9,0));
		rows.push(new Array(0,0,9,5,6,7,3,0,0));
		rows.push(new Array(0,3,8,0,0,9,0,7,2));
		rows.push(new Array(0,0,3,6,8,0,5,0,0));
		rows.push(new Array(0,1,6,7,3,0,0,0,4));
		rows.push(new Array(8,0,0,0,0,0,0,0,0));*/
		
		var rows = new Array();
		rows.push(new Array(0,8,0,9,0,2,4,0,5));
		rows.push(new Array(0,0,2,0,3,0,0,0,0));
		rows.push(new Array(0,5,0,0,0,1,0,0,8));
		rows.push(new Array(0,3,0,4,0,0,0,6,0));
		rows.push(new Array(0,4,0,0,9,0,0,1,0));
		rows.push(new Array(0,0,7,0,0,6,5,0,0));
		rows.push(new Array(7,0,0,8,0,0,0,2,0));
		rows.push(new Array(0,0,0,0,6,0,1,0,0));
		rows.push(new Array(5,0,9,1,0,3,0,4,0));

		
		draw(rows);
	}
	
	
	private function draw(initData:Array){
		//create the clips...
		startingData = initData;
		var startX = 0;
		var startY = 0;
		if(cells.length!=0){
			for(var i=0;i<9;i++){
				for(var j=0;j<9;j++){
					cell_mc.removeMovieClip();
				}
			}
		}
		
		cells = new Array();
		
		
		for(var i=0;i<9;i++){
			//column
			cells[i] = new Array();
			for(var j=0;j<9;j++){
				//row
				var cell_mc = clip.createEmptyMovieClip("cell"+i+j,i*9+j);
				var background_mc = cell_mc.createEmptyMovieClip("background_mc",2);
				background_mc.beginFill(0xFFFFFF,100);
				background_mc.lineStyle(1,0x000000,100);
				background_mc.moveTo(0,0);
				background_mc.lineTo(0,CELLWIDTH);
				background_mc.lineTo(CELLHEIGHT,CELLWIDTH);
				background_mc.lineTo(CELLHEIGHT,0);
				background_mc.lineTo(0,0);
				background_mc.endFill();
				cell_mc._x = CELLWIDTH*j;
				cell_mc._y = CELLHEIGHT*i;
				
				//textfield
				cell_mc.createTextField("text_txt",5, 5, 5, 80, 20);
				cell_mc.text_txt.type = "input";
				background_mc.onRelease = Delegate.create(this,onCellClick,cell_mc);
				
				var value = initData[i][j];
				
				
				if(initData[i][j]==0){
					cell_mc.numbers = new Array(1,2,3,4,5,6,7,8,9);
				}else{
					cell_mc.numbers = new Array();
					cell_mc.numbers[0]=value;
					cell_mc.text_txt.text = initData[i][j];
					cell_mc.text_txt.textColor = 0x00FF00;
					
				}
				
				
				cells[i].push(cell_mc);
			}
		}
		
		clip.solve_btn.onRelease = Delegate.create(this,solve);
		clip.reset_btn.onRelease = Delegate.create(this,reset);
	}
	
	function onCellClick(cell_mc){
		debug(cell_mc.numbers);
	}
	
	function reset(){
		draw(startingData);
	}
	
	function solve(){
		trace("+++++++++++++++solving+++++++++++++++++++++++");
		var isComplete = true;
		var isChange = false;
		
		
		for(var i=0;i<9;i++){
			for(var j=0;j<9;j++){
				trace("------------------------------------");
				trace("solving for cell "+i+","+j);
				
				//-----------------------------------------------
				// HORIZONTAL
				//---------------------------------------------
				//go throught the row...
				var currCell = cells[i][j];
				for(var k=0;k<9;k++){
					var compareCellValue = int(cells[i][k].text_txt.text);
					if(compareCellValue!=0&&currCell!=cells[i][k]){
						//go through the currCells numbers
						for(var n=0;n<currCell.numbers.length;n++){
							if(compareCellValue==currCell.numbers[n]){
								//splice the nth value out of the array
								trace("removing"+compareCellValue);
								currCell.numbers.splice(n,1);
								isChange = true;
							}
						}
					}
				}
				trace(" at end of horizontal "+currCell.numbers);
				//-----------------------------------------------
				// VERTICAL
				//---------------------------------------------
				for(var k=0;k<9;k++){
					var compareCellValue = int(cells[k][j].text_txt.text);
					if(compareCellValue!=0&&currCell!=cells[k][j]){
						//go through the currCells numbers
						for(var n=0;n<currCell.numbers.length;n++){
							if(compareCellValue==currCell.numbers[n]){
								//splice the nth value out of the array
								currCell.numbers.splice(n,1);
								trace("removing"+compareCellValue);
								isChange = true;
							}
						}
					}
				}
				trace(" at end of vertical "+currCell.numbers);
				//----------------------------------------------
				// IN THE SAME GRID
				//---------------------------------------------
				var hbase = Math.floor(j/3)
				var vbase = Math.floor(i/3);
				for(var k=0;k<3;k++){
					for(var l=0;l<3;l++){
						//horizontal mod
						var vCell = ((j+k)%3)+hbase*3;
						var hCell = ((i+l)%3)+vbase*3;
						if(cells[hCell][vCell]!=currCell){
							compareCellValue = int(cells[hCell][vCell].text_txt.text);
							trace("Comparing to "+hCell+","+vCell+" :"+compareCellValue);
							for(var n=0;n<currCell.numbers.length;n++){
								if(compareCellValue==currCell.numbers[n]){
									//splice the nth value out of the array
									trace("removing"+currCell.numbers[n]);
									currCell.numbers.splice(n,1);
									isChange = true;
								}
							}
						}
					}		
				}
				trace(" at end of samegrid "+currCell.numbers);
				
				if(currCell.numbers.length==1){
					trace("CHANGING CELL TO VALUE"+i+" "+j);
					if(currCell.text_txt.text==""){
						currCell.text_txt.text = currCell.numbers[0];
						currCell.text_txt.textColor = 0x0000FF;
					}
				}else if(currCell.numbers.length<=1){
					debug("SOLUTION NOT VALID"+i+" "+j);
					return false;
				}else{
					isComplete = false;
				}			
			}
		}
		
	//end of solve
		if(isComplete){
			debug("ALL COMPLETE");
			return true;
		}else if(!isChange){
			debug("ERROR NO CHANGE BUT NO SOLVE");
			return false;
		}else{
			solve();
		}
	}
	
	function debug(message:String){
		clip.output_txt.htmlText += message+"<br/>";
		trace(message);
	}
	
	

}